using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
namespace stickpart
{
public class BloodTransferer : BloodContainer
{
	
}
public class BloodSucker: MonoBehaviour {
      private void Start() {
         this.unstickyPropertySet = new List < PhysicalProperties > (this.StickyPropertiesToIgnore);
         this.StickyPropertiesToIgnore = null;
         this.objectLayer = LayerMask.NameToLayer("Objects");
         this.nocollisionLayer = LayerMask.NameToLayer("Debris");
		 gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("dsic", delegate() {
        return this.disconnectonsuck + ": Disconnect if bloodless";
      }, "Disconnect when the target has lost most of their blood", new UnityAction[] {
        delegate() {
          disconnectonsuck = !disconnectonsuck;
        }
      }));
      }
      private void Use(ActivationPropagation propag) {
		  if(propag.Contains(gameObject))
		 {return;}
         armed = !armed;
         this.DestroyJoint();
      }
      private void FixedUpdate() {
         bool flag = this.isStuck && this.joint && !this.joint.connectedBody;
         bool flag2 = !this.isStuck && this.joint;
		 //bool flag3 = disconnectonsuck
		 if(this.joint && disconnectonsuck && connectedLimb.CirculationBehaviour.BloodAmount < 0.02f)
		 {
			 //gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[1]), SendMessageOptions.DontRequireReceiver); 
			 this.DestroyJoint();
		 }
         if ((this.isStuck && !this.joint) || flag2 || flag) {
            this.DestroyJoint();
         }
      }
      public void OnCollisionEnter2D(Collision2D collision) {
         if (this.isStuck || !this.armed) {
            return;
         }
         PhysicalBehaviour phys;
         if (!this.GetPhysicalBehaviour(collision, out phys)) {
            return;
         }
		 if(!collision.gameObject.GetComponent < LimbBehaviour > ())
		 {
			 return;
		 }
		 if(collision.gameObject.GetComponent < LimbBehaviour > ().CirculationBehaviour.BloodAmount <0.02f&&disconnectonsuck)
		 {return;}
         if (!this.IsStickyWith(phys)) {
            return;
         }
         this.isStuck = true;
         this.CreateJoint(phys);
      }
      private void OnJointBreak2D(Joint2D broken) {
         if (broken != this.joint) {
            return;
         }
         this.DestroyJoint();
      }
      private bool GetPhysicalBehaviour(Collision2D collision, out PhysicalBehaviour phys) {
         return Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out phys);
      }
      private bool IsStickyWith(PhysicalBehaviour phys) {
         return !this.unstickyPropertySet.Contains(phys.Properties);
      }
      public void CreateJoint(PhysicalBehaviour phys) {
         if (this.joint) {
            UnityEngine.Object.Destroy(this.joint);
			UnityEngine.Object.Destroy(this.jointbeh);
         }
		 this.connectedLimb = phys.gameObject.GetComponent<LimbBehaviour>();
         this.joint = base.gameObject.AddComponent < DistanceJoint2D > ();
                joint.maxDistanceOnly = true;
                joint.enableCollision = false;
                joint.distance = Vector3.Distance(gameObject.transform.position,connectedLimb.gameObject.transform.position);
                joint.autoConfigureDistance = false;
                joint.breakForce = Mathf.Infinity;
                joint.breakTorque = Mathf.Infinity;
                joint.connectedBody = phys.gameObject.GetComponent<Rigidbody2D>();
				joint.anchor = new Vector2(0f, 0f);
                joint.connectedAnchor = new Vector2(0f,0f);
				BloodWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<BloodWireBehaviour>();
            energyWireBehaviour.WireColor = new Color32(100,0,0,255);
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            energyWireBehaviour.WireWidth = 0.05f;
            energyWireBehaviour.typedJoint = joint;
			jointbeh = energyWireBehaviour;
         //this.joint.connectedBody = phys.rigidbody;
         base.gameObject.layer = this.nocollisionLayer;
      }
      private void DestroyJoint() {
         base.gameObject.layer = this.objectLayer;
         this.isStuck = false;
		 connectedLimb = null;
		 gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[1]), SendMessageOptions.DontRequireReceiver);
         if (this.joint) {
            UnityEngine.Object.Destroy(this.joint);
			UnityEngine.Object.Destroy(this.jointbeh);
         }
      } [SkipSerialisation]
      public PhysicalProperties[] StickyPropertiesToIgnore = new PhysicalProperties[0];
      private bool isStuck;
	  public bool disconnectonsuck = false;
      private List < PhysicalProperties > unstickyPropertySet;
      public DistanceJoint2D joint;
	  [SkipSerialisation]
	  public LimbBehaviour connectedLimb;
	  public BloodWireBehaviour jointbeh;
      public bool armed = false;
      private int objectLayer;
      public int nocollisionLayer;
   }
}