using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
//using System.Runtime.ExceptionServices;
//using System.Security.Permissions;
using UnityEngine;
using TMPro;
using UnityEngine.Events;
//using System.Net.Http;
namespace stickpart
{
	public class PowerGate: MonoBehaviour {
      // Token: 0x06000652 RID: 1618 RVA: 0x00021C24 File Offset: 0x0001FE24
      private void Start() {
         this.PhysicalBehaviour = gameObject.GetComponent < PhysicalBehaviour > ();
         this.Light = gameObject.transform.Find("glow").gameObject;
		 this.PhysicalBehaviour.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("setresist", "Set Resistance", "Set resistance", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the resistance\n<color=green><size=26>Default: 1,Currently:"+ChosenResist+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.ChosenResist = Mathf.Clamp(setrange, -12f, 1);
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
      }
      private void FixedUpdate() {
         this.PhysicalBehaviour.EnergyWireResistance = this.ResistorPower;
      }
      private void Use() {
         if (active) {
            this.ResistorPower = 0f;
         } else {
            this.ResistorPower = ChosenResist;
         }
         active = !active;
         this.Light.SetActive(active);
      }
      public bool active = false;
	  public float ChosenResist = 1f;
      public float ResistorPower;
      [SkipSerialisation]
      public GameObject Light;
	  [SkipSerialisation]
      public PhysicalBehaviour PhysicalBehaviour;
   }
   public class velstabbh: MonoBehaviour {
      // Token: 0x06000268 RID: 616 RVA: 0x0000C4C5 File Offset: 0x0000A6C5
      private void Start() {
         this.physicalBehaviour = gameObject.GetComponent < PhysicalBehaviour > ();
         this.Light = gameObject.transform.Find("glow").gameObject;
         this.SetActivated(this.Activated);
		 refix();
		 this.physicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("chngfrz", delegate()
		{
			if (!freezex)
			{
				return "Freeze: Y";
			}
			return "Freeze: X";
		}, "Change coordinate to freeze.", new UnityAction[]
		{
			delegate()
			{
				freezex = !freezex;refix();		
			}
		}));
      }
      private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }

      // Token: 0x0600026C RID: 620 RVA: 0x0000C50E File Offset: 0x0000A70E
	  void refix()
	  {
		if(!freezex)  
		this.physicalBehaviour.rigidbody.constraints = (this.Activated ? RigidbodyConstraints2D.FreezePositionY : RigidbodyConstraints2D.None);
		else
		this.physicalBehaviour.rigidbody.constraints = (this.Activated ? RigidbodyConstraints2D.FreezePositionX : RigidbodyConstraints2D.None);
	  }
      private void SetActivated(bool activated) {
         this.Activated = activated;
         this.Light.SetActive(this.Activated);
         /*if(activated == true)
         {
             this.physicalBehaviour.rigidbody.useGravity = gravmode;
         }
         else
         {
             this.physicalBehaviour.rigidbody.useGravity = true;
         }*/
         refix();
      }

      // Token: 0x04000264 RID: 612
      public bool Activated = false;
	  public bool freezex = false;
      // Token: 0x04000265 RID: 613
      private PhysicalBehaviour physicalBehaviour;

      // Token: 0x04000266 RID: 614
      [SkipSerialisation]
      public GameObject Light;
   }
   public class StickyBehaviour: MonoBehaviour {
      private void Start() {
         //this.unstickyPropertySet = new List < PhysicalProperties > (this.StickyPropertiesToIgnore);
         //this.StickyPropertiesToIgnore = null;
		 PhysicalBehaviour pb = GetComponent<PhysicalBehaviour>();
         this.objectLayer = LayerMask.NameToLayer("Objects");
         this.nocollisionLayer = LayerMask.NameToLayer("Debris");
		 this.Light = gameObject.transform.Find("glow").gameObject;
		 this.Light.SetActive(armed);
	  }
      private void Use(ActivationPropagation activation) {
		 ushort channel = activation.Channel;
		 if(channel != 0) {return;}
         armed = !armed;
		 this.Light.SetActive(armed);
         this.DestroyJoint();
      }
      private void FixedUpdate() {
         bool flag = this.isStuck && this.joint && !this.joint.connectedBody;
         bool flag2 = !this.isStuck && this.joint;
         if ((this.isStuck && !this.joint) || flag2 || flag) {
            this.DestroyJoint();
         }
      }
      public void OnCollisionEnter2D(Collision2D collision) {
         if (this.isStuck || !this.armed) {
            return;
         }
         PhysicalBehaviour phys;
         if (!this.GetPhysicalBehaviour(collision, out phys)) {
            return;
         }
         if (!this.IsStickyWith(phys)) {
            return;
         }
         this.isStuck = true;
         this.CreateJoint(phys);
      }
      private void OnJointBreak2D(Joint2D broken) {
         if (broken != this.joint) {
            return;
         }
         this.DestroyJoint();
      }
      private bool GetPhysicalBehaviour(Collision2D collision, out PhysicalBehaviour phys) {
         return Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out phys);
      }
      private bool IsStickyWith(PhysicalBehaviour phys) {
		  return true;
      }
	  private void CreateSignal(int channel)
	  {
		  gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[channel]), SendMessageOptions.DontRequireReceiver);
	  }
      private void CreateJoint(PhysicalBehaviour phys) {
         if (this.joint) {
            UnityEngine.Object.Destroy(this.joint);
         }
         this.joint = base.gameObject.AddComponent < FixedJoint2D > ();
         this.joint.connectedBody = phys.rigidbody;
         base.gameObject.layer = this.nocollisionLayer;
		 CreateSignal(1);
      }
      private void DestroyJoint() {
         base.gameObject.layer = this.objectLayer;
         this.isStuck = false;
         if (this.joint) {
            UnityEngine.Object.Destroy(this.joint);
			CreateSignal(2);
         }
      } //[SkipSerialisation]
      //public PhysicalProperties[] StickyPropertiesToIgnore = new PhysicalProperties[0];
      private bool isStuck;
	  //public bool whitelist = true;
      //public List < PhysicalProperties > sett = new List<PhysicalProperties>();
      public FixedJoint2D joint;
      public bool armed = false;
      private int objectLayer;
	  public string hmstdve = "";
      public int nocollisionLayer;
	  [SkipSerialisation]
      public GameObject Light;
   }
   public class ActivatorBehaviour: MonoBehaviour {
      private void Start() {
         this.Light = gameObject.transform.Find("glow").gameObject;
      }
      private void Use() {
         activated = !activated;
         this.Light.SetActive(activated);
      }
      private void OnCollisionEnter2D(Collision2D collision) {
         if (!this.activated) {
            return;
         }
         PhysicalBehaviour phys;
         if (!this.GetPhysicalBehaviour(collision, out phys)) {
            return;
         }
         this.ActivateThing(collision.gameObject);
      }
      private void ActivateThing(GameObject thing) {
         foreach(ushort channel in ActivationPropagation.AllChannels) {
            thing.SendMessage("Use", new ActivationPropagation(thing, channel), SendMessageOptions.DontRequireReceiver);
         }
      }
      private bool GetPhysicalBehaviour(Collision2D collision, out PhysicalBehaviour phys) {
         return Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out phys);
      }
      public bool activated = false;
      [SkipSerialisation]
      public GameObject Light;
   }
   public class CollisionToggler : MonoBehaviour {
	   private void Start()
	   {
		   this.renderer = gameObject.GetComponent<SpriteRenderer>();
		   UpdateState();
	   }
	   void UpdateState()
	   {
		   if(this.Activated)
		   {
			   renderer.color = new Color(1f,1f,1f,1f);
			   gameObject.layer = LayerMask.NameToLayer("Objects");
		   }
		   else
		   {
			   gameObject.layer = 10;
			   renderer.color = new Color(1f,1f,1f,0.3f);
		   }
	   }
	   private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }

      // Token: 0x0600026C RID: 620 RVA: 0x0000C50E File Offset: 0x0000A70E
      private void SetActivated(bool activated) {
         this.Activated = activated;
         UpdateState();
      }
	  [SkipSerialisation]
	  public SpriteRenderer renderer;
	  public bool Activated = true;
   }
   public class debugcoll : MonoBehaviour {
	   void Start()
	   {
		   col = gameObject.GetComponent<Collider2D>();
	   }
	   void Update()
	   {
		   if(active)
		   {
		   ModAPI.Draw.Collider(col);
		   }
	   }
	   public bool active = true;
	   public Collider2D col;
   }
   public class custombat : MonoBehaviour {
	   void Awake()
	   {
		   pb = gameObject.GetComponent<PhysicalBehaviour>();
		   pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("chargeset", "Set Charge", "Sets charge.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the charge\n<color=green><size=26>Default: 10,Currently:"+currentcharge+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.currentcharge = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	   }
	   void Use() {
       if (!base.enabled) {
         return;
       }
       this.activated = !activated;
       }
	   void Update()
	   {
		   if(activated)
		   {
		   pb.Charge = currentcharge;
		   }
		   else
		   {
			   pb.Charge = 0f;
		   }
	   }
	   [SkipSerialisation]
	   public PhysicalBehaviour pb;
	   public bool activated = false;
	   public float currentcharge = 10f;
   }
   public class customweight : MonoBehaviour {
	   void Awake()
	   {
		   rbody = gameObject.GetComponent<Rigidbody2D>();
		   pb = gameObject.GetComponent<PhysicalBehaviour>();
		   pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("massset", "Set Mass", "Sets mass.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the mass\n<color=green><size=26>Default: 1,Currently:"+currentmass+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.currentmass = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	   }
	   void Use() {
       if (!base.enabled) {
         return;
       }
       this.activated = !activated;
       }
	   void FixedUpdate()
	   {
		   if(activated)
		   {
		   rbody.mass = currentmass;
		   }
		   else
		   {
			   rbody.mass = 1f;
		   }
	   }
	   [SkipSerialisation]
	   public PhysicalBehaviour pb;
	   [SkipSerialisation]
	   public Rigidbody2D rbody;
	   public bool activated = false;
	   public float currentmass = 1f;
   }
   public class floater : MonoBehaviour {
	   void Awake()
	   {
		   rbody = gameObject.GetComponent<Rigidbody2D>();
		   pb = gameObject.GetComponent<PhysicalBehaviour>();
		   properties = pb.Properties.ShallowClone();
		   pb.Properties = properties;
		   pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("floatset", "Set Buoyancy", "Sets the very hard to spell thing.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the buoyancy\n<color=green><size=26>Default: 1,Currently:"+currentfloatey+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.currentfloatey = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	   }
	   void Use() {
       if (!base.enabled) {
         return;
       }
       this.activated = !activated;
       }
	   void FixedUpdate()
	   {
		   if(activated)
		   {
		   properties.Buoyancy = currentfloatey;
		   }
		   else
		   {
			   properties.Buoyancy = 0f;
		   }
	   }
	   [SkipSerialisation]
	   public PhysicalBehaviour pb;
	   [SkipSerialisation]
	   public PhysicalProperties properties;
	   [SkipSerialisation]
	   public Rigidbody2D rbody;
	   public bool activated = false;
	   public float currentfloatey = 1f;
   }
   public class BeepyBehaviour: MonoBehaviour {
     void Start() {
		 //downloadmp3(@"https://cdn.discordapp.com/attachments/791671869346414606/833012072777908274/whatthefuckisthismenu.wav",@"F:\Desktop\whatthefuckisthismenu.wav");
       try {
         //downloadmp3(@"https://cdn.discordapp.com/attachments/791671869346414606/833012072777908274/whatthefuckisthismenu.wav");
		 downloadmp3(urldownload);
         audio.pitch = this.audiopitch;
		 //audio.loop = this.loop;
         pb = gameObject.GetComponent < PhysicalBehaviour > ();
         pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("pitchset", "Set Pitch", "Sets pitch.", () => {
           DialogBox dialog = (DialogBox) null;
           dialog = DialogBoxManager.TextEntry("Enter pitch\n<color=green><size=26>Default: 1,Currently:" + audiopitch + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
               (UnityAction)(() => {
                 float setrange;
                 if (float.TryParse(dialog.EnteredText, out setrange)) {
                   this.audiopitch = setrange;
                   audio.pitch = this.audiopitch;
                 }
               })
             }),
             new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
         }));
		 pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("volumeset", "Set Volume", "Sets volume.", () => {
           DialogBox dialog = (DialogBox) null;
           dialog = DialogBoxManager.TextEntry("Enter volume\n<color=green><size=26>Default: 1,Currently:" + audiovol + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
               (UnityAction)(() => {
                 float setrange;
                 if (float.TryParse(dialog.EnteredText, out setrange)) {
                   audiovol = setrange;
                 }
               })
             }),
             new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
         }));
		 pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("stopcum","Stop Sounds", "Stop all sounds", new UnityAction[] {
        delegate() {
          audio.Stop();
        }
      }));
	  pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("turl", delegate() {
        return this.urlmode + ": Url Mode";
      }, "Toggle if to use URLs", new UnityAction[] {
        delegate() {
          urlmode = !urlmode;
        }
      }));
	  pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("urlset", "Set Audio URL", "Put your url in it, doesnt work with youtube.", () => {
           DialogBox dialog = (DialogBox) null;
           dialog = DialogBoxManager.TextEntry("Enter URL (no youtube)\n<color=green><size=26>Currently:" + urldownload + "</size></color>", "URL", new DialogButton("Apply", true, new UnityAction[1] {
               (UnityAction)(() => {
                 if(!String.IsNullOrWhiteSpace(dialog.EnteredText))
				 {
					 urldownload = dialog.EnteredText;
					 downloadmp3(urldownload);
				 }
               })
             }),
             new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
         }));
       } catch (Exception e) {
         Debug.Log("caught error in Start");
         Debug.Log(e.ToString());
         Debug.Log(e.StackTrace);
       }
     }
     void Use(ActivationPropagation activation) {
		 if(activation.Contains(gameObject))
		 {return;}
       try {
         audio.pitch = this.audiopitch;
         ushort channel = activation.Channel;
         if (!urlmode) {
           if (channel == 0) {
             audio.PlayOneShot(audioclip, audiovol);
           } else if (channel == 1) {
             audio.PlayOneShot(audioclipB, audiovol);
           }
         } else {
			 if(urlclip && channel!=2)
           audio.PlayOneShot(urlclip, audiovol);
         }
		 if(channel==2)
		 {audio.Stop();}
       } catch (Exception e) {
         Debug.Log("caught error in Use");
         Debug.Log(e.ToString());
         Debug.Log(e.StackTrace);
       }
     }
      async void downloadmp3(string path) {
		  Action<AudioClip> workaround = s => urlclip=s;
		  ContraptionUtilities.mp3Download(path,workaround,"beeper");
		//public static AudioClip FileToAudioClip(string path)
     }
	 //public bool loop = false;
	 public float audiovol = 1f;
	 public string urldownload = "";
     public float audiopitch = 1f;
	 public bool urlmode = false;
     [SkipSerialisation]
     public AudioSource audio;
     [SkipSerialisation]
     public AudioClip urlclip;
     [SkipSerialisation]
     public AudioClip audioclip;
     [SkipSerialisation]
     public AudioClip audioclipB;
     [SkipSerialisation]
     public PhysicalBehaviour pb;
   }
   public class ConstantActivator : MonoBehaviour
   {
	   void Use(ActivationPropagation activation)
	   {
		   ushort channel = activation.Channel;
		   if (channel != 0)
		   {
		   return;
		   }
		   activated = !activated;
	   }
	   void FixedUpdate()
	   {
		   if(activated)
		   {
			   whatever += 1f;
			   if (whatever >= 2f)
			   {
			   gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[2]), SendMessageOptions.DontRequireReceiver); 
		  gameObject.SendMessage("UseContinuous", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[1]), SendMessageOptions.DontRequireReceiver); 
		   }}
	   }
	   [SkipSerialisation]
	   public float whatever = 0f;
	public bool activated = true;
   }
   public class AnchorBlockBehaviour: MonoBehaviour {
      private void Awake() {
         this.physicalBehaviour = base.GetComponent < PhysicalBehaviour > ();
         //this.Light = gameObject.transform.Find("glow").gameObject;
      }

      private void Start() {
         this.SetActivated(this.Activated);
      }

      private void FixedUpdate() {
         RigidbodyType2D bodyType = this.physicalBehaviour.rigidbody.bodyType;
      }

      private void Use() {
         if (!base.enabled) {
            return;
         }
         this.SetActivated(!this.Activated);
      }

      private void SetActivated(bool activated) {
         this.Activated = activated;
         this.light.SetActive(this.Activated);
         this.physicalBehaviour.rigidbody.constraints = (this.Activated ? RigidbodyConstraints2D.FreezeAll : RigidbodyConstraints2D.None);
      }

      private void OnDisable() {
         this.SetActivated(false);
      }
      public GameObject light;
      public bool Activated = false;
      private PhysicalBehaviour physicalBehaviour;
      /*[SkipSerialisation]
      public GameObject Light;*/
   }
   public class WaterSensor: MonoBehaviour {
     public void Start() {
       namekeys = new Dictionary < int, string > () {
         {
           0,
           "Continuous"
         }, {
           1,
           "Single Trigger"
         }, {
           2,
           "Double Trigger"
         }
       };
	   PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>() as PhysicalBehaviour;
	   pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("changemode", delegate()
		{
			return "Current Mode: "+namekeys[mode];
		}, "Change detection mode", new UnityAction[]
		{
			delegate()
			{
				int proccesing = mode;
				proccesing += 1;
				//there is definently a better way to limit it
				if(proccesing > maxmode)
				{
					proccesing = 0;
				}
				mode = proccesing;
			}
		}));
		Setup();
     }
	 public virtual void Setup(){}
	 public virtual bool CanPass() 
	 {
		 return WaterBehaviour.IsPointUnderWater(gameObject.transform.position);
	 }
	 public virtual void PerUpdate() {}
     public virtual void FixedUpdate() {
		 PerUpdate();
       if (mode == 0) {
         bool flag = CanPass();
         if (flag) {
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("UseContinuous", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
       } else {
         bool flag = CanPass();
         if (flag && !variable1) {
           variable1 = true;
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
         if (!flag && variable1) {
           variable1 = false;
           if (mode == 2) {
             foreach(ushort channel in ActivationPropagation.AllChannels) {
               gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
             }
           }
         }
       }
     }
	 public int maxmode = 2;
     public Dictionary < int, string > namekeys;
     public bool variable1 = false;
     public int mode = 0; //0-Continuous 1-Single Trigger 2-Double Trigger
   }
   public class MousePartBehaviour: MonoBehaviour {
  private void Start() {
    this.rb = gameObject.GetComponent < Rigidbody2D > ();
	this.globalinstance = UnityEngine.Object.FindObjectsOfType<Global>()[0];
	AdvancedRecheck();
	PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>() as PhysicalBehaviour;
	 this.initialHealth = this.Health;
		this.RandomOffset = new Vector4(UnityEngine.Random.value * 1000f, UnityEngine.Random.value * 1000f);
		this.SpriteRenderer = base.GetComponent<SpriteRenderer>();
		this.PhysicalBehaviour = pb;
		this.originalMaterial = this.SpriteRenderer.sharedMaterial;
		this.brokenMachineMaterial = Resources.Load<Material>("Materials/BrokenMachine");
		if (!this.SparkPrefab)
		{
			this.SparkPrefab = Resources.Load<GameObject>("Prefabs/BrokenElectronicsSpark");
		}
		this.propertyBlock = new MaterialPropertyBlock();
		this.SpriteRenderer.GetPropertyBlock(this.propertyBlock);
		if (this.Destroyed)
		{
			this.SetAsBroken();
		}
	pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleadvanced", delegate()
		{
			if (!advancedmode)
			{
				return "Strong Mode: OFF";
			}
			return "Strong Mode: ON";
		}, "Makes the player stronger but also disables physics sadly", new UnityAction[]
		{
			delegate()
			{
				advancedmode = !advancedmode;
				AdvancedRecheck();
                
			}
		}));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("togglemove", delegate()
		{
			if (!canmove)
			{
				return "Can Move: No";
			}
			return "Can Move: Yes";
		}, "Toggle if it can move", new UnityAction[]
		{
			delegate()
			{
				canmove = !canmove;
                
			}
		}));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleMouse", delegate()
		{
			if (!usemouse)
			{
				return "Use Mouse: No";
			}
			return "Use Mouse: Yes";
		}, "Toggles if to use the mouse", new UnityAction[]
		{
			delegate()
			{
				usemouse = !usemouse;
                
			}
		}));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("allowsprint", delegate()
		{
			if (!sprintallowed)
			{
				return "Sprinting Allowed: No";
			}
			return "Sprinting Allowed: Yes";
		}, "Toggle if sprinting is allowed", new UnityAction[]
		{
			delegate()
			{
				sprintallowed = !sprintallowed;
                
			}
		}));
		   pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("speedset", "Set Speed", "Sets speed.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter speed\n<color=green><size=26>Default: 1,Currently:"+this.speed+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.speed = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("sspeedset", "Set Sprint Multiplier", "Set Sprint Multiplier", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter speed\n<color=green><size=26>Default: *1.3,Currently: * "+this.sprintspeedmultiplier+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.sprintspeedmultiplier = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			this.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("repairMachinery", "Repair", "Repair broken machinery", new UnityAction[]
		{
			delegate()
			{
				this.Health = this.initialHealth;
				this.ActOnRepair();
			}
		})
		{
			Condition = (() => this.Destroyed)
		});
	 this.PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("healthchang",  delegate(){return this.Health+": Change Health";}, "Change health", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter HP\n<color=green><size=26>Default: 200,Currently:"+this.Health+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.initialHealth = setrange;
					  this.Health = setrange;
					  this.ActOnRepair();
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
  }
  //Handle Damage
		public void OnEMPHit()
	{
		this.SetAsBroken();
		UnityEngine.Object.Instantiate<GameObject>(this.SparkPrefab, base.transform.position, Quaternion.identity);
	}
		private void Shot(Shot shot)
		{
			this.Health -= shot.damage/4f;
			this.ActOnDamage();
		}
		private void ActOnDamage()
	{
		UnityEngine.Object.Instantiate<GameObject>(this.SparkPrefab, base.transform.position, Quaternion.identity);
		if (this.Health > 0f || this.Destroyed)
		{
			return;
		}
		this.SetAsBroken();
	}private void Slice()
	{
		this.Health -= 70f;
		this.ActOnDamage();
	}
	public void Repair()
	{
		this.Health += this.initialHealth / 3f;
		this.Health = Mathf.Clamp(this.Health, 0f, this.initialHealth);
		this.ActOnRepair();
	}

	private void ActOnRepair()
	{
		if (this.Health <= 0.001f)
		{
			return;
		}
		this.PhysicalBehaviour.BurnProgress = 0f;
		this.Destroyed = false;
		this.SpriteRenderer.sharedMaterial = this.originalMaterial;
	}
	private void SetAsBroken()
	{
		this.SetActivated(true);
		this.Destroyed = true;
		this.Health = 0f;
		this.SetActivated(false);
		this.SpriteRenderer.sharedMaterial = this.brokenMachineMaterial;
		this.propertyBlock.SetVector("_Offset", this.RandomOffset);
		this.SpriteRenderer.SetPropertyBlock(this.propertyBlock);
	}
		//End Handling Damage
  private void Use() {
    if (!base.enabled && !Destroyed) {
      return;
    }
    this.SetActivated(!this.activated);
  }
  private void SetActivated(bool activated) {
    this.activated = activated;
  }
  private void AdvancedRecheck()
  {
	if (advancedmode)
	{
rb.mass = 45f;
					 rb.isKinematic = true;
					 rb.gravityScale = 0.0f;
	}
else
{
	rb.mass = 6f;
					 rb.isKinematic = false;
					 rb.gravityScale = 0f;
}
  }
  private void RotateTowards(Vector2 target) {
	  if(Vector3.Distance(gameObject.transform.position,new Vector3(target.x,target.y,0f)) < 0.1f) {return;}
    var offset = 0f;
    Vector2 direction = target - (Vector2) transform.position;
    direction.Normalize();
    float angle = Mathf.Atan2(direction.y, direction.x) * Mathf.Rad2Deg;
	if(transform.localScale.x < 0)
			{
				offset = 180f;
			}
    //RB.SetRotation(Quaternion.Euler(Vector3.forward * (angle + offset)));
    for (int i = 0; i < 25; i++) {
      rb.MoveRotation(Quaternion.Euler(Vector3.forward * (angle + offset)));
    }

  }
  void Update()
  {
	  if (activated && !globalinstance.Paused && !Destroyed)
	  {
		  if(canmove)
		  {
		  float fakespeed = speed;
			  
 if (Input.GetKey(KeyCode.LeftShift) && sprintallowed) {
     fakespeed *= sprintspeedmultiplier;
 }
 else if (Input.GetKey(KeyCode.LeftAlt)) {
     fakespeed = speed/2;
 }
 float h = Input.GetAxisRaw("Horizontal")* (fakespeed*4);
 float v = Input.GetAxisRaw("Vertical")* (fakespeed*4);
 Vector3 inputVector = new Vector2( h, v );
 inputVector.Normalize();
rb.MovePosition(transform.position + inputVector * fakespeed * Time.deltaTime);
		  }
		  if(usemouse)
		 {
			 Vector3 pz = Camera.main.ScreenToWorldPoint(Input.mousePosition);
pz.z = 0;
			 RotateTowards(new Vector2(pz.x,pz.y));
		 }
	  }
  }
  public bool canmove = true;
  public bool sprintallowed = true;
  public bool advancedmode = false;
  public bool usemouse = true;
  public float speed = 10f;
  public float sprintspeedmultiplier = 1.3f;
  public float initialHealth = 200f;
	 public float Health = 200f;
  public bool activated = false;
  [SkipSerialisation]
  public Global globalinstance;
  [SkipSerialisation]
  public Rigidbody2D rb;
  public bool Destroyed;
	 [SkipSerialisation]
	private SpriteRenderer SpriteRenderer;
	[SkipSerialisation]
	public PhysicalBehaviour PhysicalBehaviour;
	 [SkipSerialisation]
	public GameObject SparkPrefab;
	[SkipSerialisation]
	public Vector4 RandomOffset;
private float t;
	// Token: 0x040001C8 RID: 456
public const float SparkChancePerSecond = 1E-05f;
	// Token: 0x040001CA RID: 458
	[SkipSerialisation]
	private Material originalMaterial;

	// Token: 0x040001CB RID: 459
	[SkipSerialisation]
	private Material brokenMachineMaterial;

	// Token: 0x040001CC RID: 460
	[SkipSerialisation]
	private MaterialPropertyBlock propertyBlock;
}
public class Killblock : MonoBehaviour
{
	void Start()
	{
		this.renderer = gameObject.GetComponent < SpriteRenderer > ();
		ChangeEndpointStatus();
		UpdateActiveState();
		PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>() as PhysicalBehaviour;
	pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tendpoint", delegate()
		{
			if (!IsEndpoint)
			{
				return "Is Endpoint: No";
			}
			return "Is Endpoint: Yes";
		}, "Makes teleporters teleport to this.", new UnityAction[]
		{
			delegate()
			{
				IsEndpoint = !IsEndpoint;
				ChangeEndpointStatus();
                
			}
		}));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("tunfrozen", delegate()
		{
			if (!teleportnonplayer)
			{
				return "Teleport All: No";
			}
			return "Teleport All: Yes";
		}, "Toggle if to teleport all unfrozen objects", new UnityAction[]
		{
			delegate()
			{
				teleportnonplayer = !teleportnonplayer;
                
			}
		}));
		 pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setchannel", "Set Channel", "Sets the channel.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("What channel?\n<color=green><size=26>Currently:"+this.TeleporterSignal+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
					  if(!String.IsNullOrWhiteSpace(dialog.EnteredText))
					  {
                      this.TeleporterSignal = dialog.EnteredText;
					  }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	}
	void UpdateActiveState()
	{
		if(IsActive)
		{
			ChangeEndpointStatus();
		}
		else
		{
			renderer.sprite = UnactivePortal;
			gameObject.layer = 10;
		}
	}
	void Use(ActivationPropagation activation) {
		 ushort channel = activation.Channel;
		 if(channel == 2) {return;}
		this.IsActive = !this.IsActive;
		UpdateActiveState();
	}
	void ChangeEndpointStatus()
	{
		if(IsEndpoint)
		{
			renderer.sprite = OrangePortal;
			gameObject.layer = 10;
		}
		else
		{
			renderer.sprite = BluePortal;
			gameObject.layer = LayerMask.NameToLayer("Objects");
		}
	}
	Killblock GetTeleporter() {
  List < Killblock > Suitables = new List < Killblock > ();
  Killblock[] checkobjects = GameObject.FindObjectsOfType(typeof (Killblock)) as Killblock[];
  for (int i = 0; i < checkobjects.Length; i++) {
    Killblock Tele = checkobjects[i];
    if (Tele.IsActive && Tele.IsEndpoint &&Tele.TeleporterSignal == this.TeleporterSignal) {
      Suitables.Add(Tele);
    }
  }
  var random = new System.Random();
  if(Suitables.Count > 0)
  {
  return Suitables[random.Next(Suitables.Count)];
  }
  return null;
}
void MakeEffect()
{
	ModAPI.CreateParticleEffect("Disintegration", gameObject.transform.position);
	gameObject.SendMessage("Use", new ActivationPropagation(gameObject, ActivationPropagation.AllChannels[2]), SendMessageOptions.DontRequireReceiver);
}
	void OnCollisionEnter2D(Collision2D col)
	{
		if(!IsEndpoint && IsActive)
		{
			if(!teleportnonplayer && col.gameObject.name != "PlayerPart")
			{
				return;
			}
			if(teleportnonplayer && col.gameObject.name == "MinigameTeleporter")
			{
				return;
			}
			if(col.gameObject.layer == 11) // teleporting walls is VERY bad
			{
				return;
			}
			if(teleportnonplayer)
			{
				FreezeBehaviour freeze = col.gameObject.GetComponent<FreezeBehaviour>() as FreezeBehaviour;
				if(freeze)
				{
					return;
				}
			}
			Killblock othertpCODE = GetTeleporter();
			if(othertpCODE)
			{
			GameObject player = col.gameObject;
			//Rigidbody2D playerpb = player.GetComponent<Rigidbody2D>() as Rigidbody2D;
			//bool waskinematic = playerpb.isKinematic;
			MakeEffect();
			GameObject othertp = othertpCODE.gameObject;
			othertp.BroadcastMessage("MakeEffect",SendMessageOptions.RequireReceiver);
			//if(!waskinematic)
			//{
			//	playerpb.isKinematic = true;
			//}
			player.transform.position = othertp.transform.position;
			player.transform.rotation = othertp.transform.rotation;
			//if(!waskinematic)
			//{
			//	playerpb.isKinematic = false;
			//}
			}
		}
	}
	public bool IsActive = true;
	public bool teleportnonplayer = false;
	public string TeleporterSignal = "0";
	public bool IsEndpoint = false;
	[SkipSerialisation]
	public SpriteRenderer renderer;
	[SkipSerialisation]
	public Sprite BluePortal;
	[SkipSerialisation]
	public Sprite OrangePortal;
	[SkipSerialisation]
	public Sprite UnactivePortal;
}
public class CustomizableAD : MonoBehaviour
{
	void Start()
	{
		pb = gameObject.GetComponent<PhysicalBehaviour>();
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("delayset", "Set Activation Delay", "Set Activation Delay", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the delay in seconds.\n<color=green><size=26>Default: 0,Currently:"+this.delay+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.delay = setrange;
					  Resync();
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	}
	void Resync()
	{
		pb.ActivationPropagationDelay = delay;
	}
	public float delay = 0f;
	[SkipSerialisation]
	public PhysicalBehaviour pb;
}
public class BlockEditor : MonoBehaviour
{
	public void Start()
	{
		//parts.Add(gameObject.transform.Find("rootblock").gameObject);
		if(startedonce)
		{
			gameObject.GetComponent<SpriteRenderer>().sprite = null;
			Stop();
			return;
		}
		startedonce = true;
		UpdateGizmo(parts[blockenumerator].transform);
	}
	public void UpdateGizmo(Transform parent)
	{
		if(arrowsgizmo)
		{
			UnityEngine.Object.Destroy(arrowsgizmo);
		}
		var childObject = new GameObject("ArrowsGizmo");
		childObject.transform.SetParent(parent);
		childObject.transform.localPosition = new Vector3(0f, 0f);
		var childSprite = childObject.AddComponent < SpriteRenderer > ();
		childSprite.sprite = ModAPI.LoadSprite("arrows_gizmo.png");
		childSprite.sortingLayerName = "Top";
		this.arrowsgizmo = childObject;
	}
	public void makeobject(Vector3 pos)
	{
		var newobject = ModAPI.CreatePhysicalObject("Clonepart", Skins[spriteindex]);
		newobject.transform.SetParent(gameObject.transform);
		newobject.GetComponent<Rigidbody2D>().isKinematic = true;
		newobject.transform.position = pos;
		newobject.transform.rotation = Quaternion.Euler(0,0,angle);
		blockenumerator += 1;
		parts.Add(newobject);
		UpdateGizmo(newobject.transform);
	}
	//broken
	/*public void Unfreezeall()
	{
		GameObject rootobject = parts[0];
		foreach(GameObject part in parts)
		{
			FixedJoint2D joint = rootobject.AddComponent<FixedJoint2D>();
			joint.connectedBody = part.GetComponent<Rigidbody2D>();
			joint.enableCollision = false;
			part.GetComponent<Rigidbody2D>().isKinematic = false;
		}
	}*/
	public void Stop()
	{
		if(arrowsgizmo)
		{
		UnityEngine.Object.Destroy(arrowsgizmo);
		}
		UnityEngine.Object.Destroy(this);
	}
	public void Update()
	{
		Transform thisthing = parts[blockenumerator].transform;
         if (Input.GetKeyUp(KeyCode.A))
		 {
			 makeobject(thisthing.position + new Vector3(-offset,0,0));
		 }
		 if (Input.GetKeyUp(KeyCode.D))
		 {
			 makeobject(thisthing.position + new Vector3(offset,0,0));
		 }
		 if (Input.GetKeyUp(KeyCode.W))
		 {
			 makeobject(thisthing.position + new Vector3(0,offset,0));
		 }
		 if (Input.GetKeyUp(KeyCode.S))
		 {
			 makeobject(thisthing.position + new Vector3(0,-offset,0));
		 }
		 if (Input.GetKeyUp(KeyCode.Return))
		 {
			 Stop();
		 }
		 if (Input.GetKeyDown(KeyCode.R))
		 {
			 angle = Mathf.Clamp(angle-15, -180, 180);
			 parts[blockenumerator].transform.rotation = Quaternion.Euler(0,0,angle);
		 }
		 if (Input.GetKeyDown(KeyCode.T))
		 {
			 angle = Mathf.Clamp(angle+15, -180, 180);
			 parts[blockenumerator].transform.rotation = Quaternion.Euler(0,0,angle);
		 }
		 if (Input.GetKeyUp(KeyCode.U))
		 {
			 spriteindex = Mathf.Clamp(spriteindex-1, 0, Skins.Length);
			 parts[blockenumerator].GetComponent<SpriteRenderer>().sprite = Skins[spriteindex];
		 }
		 if (Input.GetKeyUp(KeyCode.I))
		 {
			 spriteindex = Mathf.Clamp(spriteindex+1, 0, Skins.Length);
			 parts[blockenumerator].GetComponent<SpriteRenderer>().sprite = Skins[spriteindex];
		 }
		 if (Input.GetKeyUp(KeyCode.Backspace))
		 {
			 if(blockenumerator > 0)
			 {
				 blockenumerator -= 1;
				 UpdateGizmo(parts[blockenumerator].transform);
			 }
		 }
	}
	public bool startedonce = false;
	public float angle = 0f;
	public GameObject arrowsgizmo;
	public int spriteindex = 0;
	public int blockenumerator = -1;
	[SkipSerialisation]
	public Sprite[] Skins = new Sprite[]{ModAPI.LoadSprite("editorblocks/typeone.png"),ModAPI.LoadSprite("editorblocks/typetwo.png")};
	[SkipSerialisation]
	public float offset = 0.225f;
	public List<GameObject> parts = new List<GameObject>();
}
   public class LightSensor: WaterSensor {
	 public override void Setup() {
		 lightbeh = UnityEngine.GameObject.FindObjectsOfType<MapLightBehaviour>()[0];
		 PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>() as PhysicalBehaviour;
	pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("invertt", delegate()
		{
			if (!inverted)
			{
				return "Invert : No";
			}
			return "Invert : Yes";
		}, "Invert", new UnityAction[]
		{
			delegate()
			{
				inverted = !inverted;
			}
		}));
	 }
     public override void FixedUpdate() {
       if (mode == 0) {
         bool flag = inverted ^ lightbeh.Activated;
         if (flag) {
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("UseContinuous", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
       } else {
         bool flag =  inverted ^ lightbeh.Activated;
         if (flag && !variable1) {
           variable1 = true;
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
         if (!flag && variable1) {
           variable1 = inverted ^ lightbeh.Activated;
           if (mode == 2) {
             foreach(ushort channel in ActivationPropagation.AllChannels) {
               gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
             }
           }
         }
       }
     }
	 public bool inverted = false;
	 private MapLightBehaviour lightbeh;
   }
public class CollisionLister : MonoBehaviour
{
	void Use()
	{
		activated = !activated;
	}
	void OnCollisionEnter2D(Collision2D col)
	{
		if(activated)
		{
				  Debug.Log("Components of: " + col.gameObject.name);
    Component[] components = col.gameObject.GetComponents(typeof(Component));
foreach(Component component in components) {
    Debug.Log(component.ToString());
}
Debug.Log("Children of: " + col.gameObject.name);
foreach (Transform child in col.gameObject.transform)
{
  Debug.Log(child.gameObject.name);
}
		}
	}
	public bool activated = false;
}
public class AngleSensor : WaterSensor {
	 public override void Setup() {
		 PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>() as PhysicalBehaviour;
	pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("invertt", delegate()
		{
			if (!inverted)
			{
				return "Invert : No";
			}
			return "Invert : Yes";
		}, "Invert", new UnityAction[]
		{
			delegate()
			{
				inverted = !inverted;
			}
		}));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("mina", "Set Min. Angle", "Set Min. Angle", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter angle\n<color=green><size=26>Default: 45,Currently:"+this.minangle+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.minangle = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("Maxa", "Set Max. Angle", "Set Max. Angle", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter angle\n<color=green><size=26>Default: 90,Currently:"+this.maxangle+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.maxangle = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	 }
	 bool flagfunc() {
		 float curangle = transform.eulerAngles.z;
		 if(transform.localScale.z < 0)
		 {
			 curangle = -transform.eulerAngles.z;
		 }
		 if(curangle >= minangle && curangle <= maxangle)
		 {
			 //Debug.Log("Correct angle!");
			 return true;
		 }
		 else
		 {
			 return false;
		 }
	 }
     public override void FixedUpdate() {
       if (mode == 0) {
         bool flag = inverted ^ flagfunc();
         if (flag) {
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("UseContinuous", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
       } else {
         bool flag = inverted ^ flagfunc();
         if (flag && !variable1) {
           variable1 = true;
           foreach(ushort channel in ActivationPropagation.AllChannels) {
             gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
           }
         }
         if (!flag && variable1) {
           variable1 = inverted ^ flagfunc();
           if (mode == 2) {
             foreach(ushort channel in ActivationPropagation.AllChannels) {
               gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
             }
           }
         }
       }
     }
	 public float minangle = 45f;
	 public float maxangle = 90f;
	 public bool inverted = false;
   }
   public class OmnisensorBehaviour: MonoBehaviour 
    {
	   void Awake()
	   {
           Detector = gameObject.GetComponent<DetectorBehaviour>();
		   PhysicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();

            PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("LifeMode", delegate()
            {
            if (!LifeMode)
            {
	          	return "Life Mode: Off";
            }
              return "Life Mode: On";
            }, "Toggle whether the thing detected has to be alive for an activation", new UnityAction[]
            {
            delegate()
            {
                LifeMode = !LifeMode;
                if(!LifeMode)
                {
                    Detector.HasToBeAlive = false;
                }
                else
                {
                    Detector.HasToBeAlive = true;
                }
            }
        }));

        PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("FireMode", delegate()
            {
            if (!FireMode)
            {
	          	return "Fire Mode: Off";
            }
              return "Fire Mode: On";
            }, "Toggle whether the thing detected has to be on fire for an activation", new UnityAction[]
            {
            delegate()
            {
                FireMode = !FireMode;
                if(!FireMode)
                {
                    Detector.HasToBeOnFire = false;
                }
                else
                {
                    Detector.HasToBeOnFire = true;
                }
            }
        }));

        PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetRange", "Set Range", "Sets Range.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the range\n<color=green><size=26>Default: 5,Currently:"+CurrentRange+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange1;
                    if (float.TryParse(dialog.EnteredText, out setrange1)) {
                        if(setrange1 > 0)
                        {
                            Detector.Range = setrange1;
                            CurrentRange = setrange1;
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error: Range must be above 0.</color>");
                        }
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

        PhysicalBehaviour.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetRelativeVelocityThreshold", "Set Relative Velocity Threshold", "Sets Relative Velocity Threshold.", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the relative velocity threshold\n<color=green><size=26>Default: 0,Currently:"+CurrentVelocity+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange2;
                    if (float.TryParse(dialog.EnteredText, out setrange2)) {
                        if(setrange2 > -0.0000000000001)
                        {
                            Detector.RelativeVelocityThreshold = setrange2;
                            CurrentVelocity = setrange2;
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error: Relative velocity threshold must be above or equal to 0.</color>");
                        }
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
	   }
       [SkipSerialisation]
	   public PhysicalBehaviour PhysicalBehaviour;
       [SkipSerialisation]
       public DetectorBehaviour Detector;
       public bool LifeMode = false;
       public bool FireMode = false;
       public float CurrentRange = 5f;
       public float CurrentVelocity = 0f;
    }
		public class LightblockBehaviour : MonoBehaviour
	{
		void ColorSync()
		{
			Color32 lccc = new Color32(lr,lg,lb,255);
			lightcolor = lccc;
		this.lightsprite.Color = lccc;
		this.light.GetComponent<SpriteRenderer>().color = lccc;
		this.lightsprite.Radius = lightradius;
		//Debug.Log(ColorUtility.ToHtmlStringRGBA(lightcolor));
		}
		void Start()
		{
			light = gameObject.transform.Find("glow").gameObject;
			lightcolor = new Color32((byte)lr,(byte)lg,(byte)lb,255);
			ColorSync();
			pb = gameObject.GetComponent<PhysicalBehaviour>();
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("setcolr", "Set Color", "Set Color", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the color\n<color="+"#"+ColorUtility.ToHtmlStringRGBA(lightcolor)+"><size=26>Default: Green,Currently:"+this.lightcolor.ToString()+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
					Color yag;
						if (ColorUtility.TryParseHtmlString(dialog.EnteredText, out yag))
						{
							Color32 yagh = yag;
							lr = yagh.r;lg = yagh.g;lb = yagh.b;ColorSync();}else{Debug.Log("Could not set color...");}
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
			pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("sat", "Set Light Radius", "Set Light Radius", () => {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter radius\n<color=green><size=26>Default: 5,Currently:"+this.lightradius+"</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      this.lightradius = setrange;
                    }
                  })
                }),
                  new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
		}
		private void UseContinuous() {
	  this.light.SetActive(true);
	  framebuff = 0;
	  this.lightsprite.Brightness = 2;
	  this.lightsprite.Radius = lightradius;
    }
		private void FixedUpdate()
	{
		if(framebuff == 25)
		{
			framebuff = 0;
		this.light.SetActive(false);
		this.lightsprite.Brightness = 0;
		}
		else
		{
			framebuff++;
		}
	}
	public byte lr = 76;public byte lg = 255;public byte lb = 0;public byte la = 255;
	  [SkipSerialisation]
	  Color32 lightcolor;
		[SkipSerialisation]
	private int framebuff = 0;
	[SkipSerialisation]
	public float lightradius = 5f;
	[SkipSerialisation]
	PhysicalBehaviour pb;
	[SkipSerialisation]
	public LightSprite lightsprite;
	[SkipSerialisation]
		GameObject light;
	}
	public class RepeaterBehaviour : MonoBehaviour {
	  void Start() {
	    light = gameObject.transform.Find("glow").gameObject;
	    pb = gameObject.GetComponent < PhysicalBehaviour > ();
		StartCoroutine(StartRepeating());
	    pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("sat", "Set Interval", "Set Repeat Interval", () => {
	      DialogBox dialog = (DialogBox) null;
	      dialog = DialogBoxManager.TextEntry("Enter the interval (in seconds)\n<color=green><size=26>Default: 1,Currently:" + this.timermax + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
	          (UnityAction)(() => {
	            float setrange;
	            if (float.TryParse(dialog.EnteredText, out setrange)) {
	              this.timermax = setrange;
	            }
	          })
	        }),
	        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
	    }));
		pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("satc", "Set Chance", "Set the chance an activation passes", () => {
	      DialogBox dialog = (DialogBox) null;
	      dialog = DialogBoxManager.TextEntry("Enter the chance\n<color=green><size=26>Default: 100%,Currently:" + this.chance + "%</size></color>", "0-100%", new DialogButton("Apply", true, new UnityAction[1] {
	          (UnityAction)(() => {
	            float setrange;
	            if (float.TryParse(dialog.EnteredText, out setrange)) {
	              this.chance = setrange/100;
	            }
	          })
	        }),
	        new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
	    }));
	  }
	  void Use(ActivationPropagation propag)
	  {
		  if(!propag.Contains(gameObject))
		  {
		  activated = !activated;
		  }
	  }
	  IEnumerator StartRepeating() {
      while (true) {
		  if(activated)
		  {
			  TurnOn();
        yield
        return new WaitForSeconds(timermax);
		TurnOff();
        Output();
		  }
        yield
        return null;
      }
      }
	  void Output()
	  {
		  if(!(UnityEngine.Random.value < chance))
		  {return;}
		  foreach(ushort channel in ActivationPropagation.AllChannels) {
        gameObject.SendMessage("Use", new ActivationPropagation(gameObject, channel), SendMessageOptions.DontRequireReceiver);
      }
	  }
	  public void TurnOn() {
	    this.light.SetActive(true);
	    this.lightsprite.Brightness = 2;
	  }
	  public void TurnOff() {
	    this.light.SetActive(false);
	    this.lightsprite.Brightness = 0;
	  }
	  public float timermax = 1;
	  public float chance = 1; //100% = 1,50% = 0.50, 50 / 100 = 0.50
	  public bool activated = false;
	  [SkipSerialisation]
	  PhysicalBehaviour pb;
	  [SkipSerialisation]
	  public LightSprite lightsprite;
	  [SkipSerialisation]
	  GameObject light;
	}
	public class ActivationGate2 : MonoBehaviour {
		public void Start()
		{
			PhysBeh = gameObject.GetComponent<PhysicalBehaviour>();
			light = gameObject.transform.Find("glow").gameObject;
			this.light.SetActive(Active);
		}
		public void Use(ActivationPropagation propag)
		{
			if(propag.Channel == 2)
			{
				Active = true;
			}
			else if(propag.Channel == 1)
			{
				Active = false;
			}
			this.light.SetActive(Active);
		}
		public void Update()
		{
			this.PhysBeh.ActivationPropagationDelay = (Active ? 0f : -1f);
		}
		public bool Active = true;
		[SkipSerialisation]
		public PhysicalBehaviour PhysBeh;
		[SkipSerialisation]
	    public GameObject light;
	}
}