using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using TMPro;
using UnityEngine.Events;
//using System.Net.Http;
namespace stickpart
{
	public class UnfuckedBinding : FixedJointWireBehaviour
{
	// Token: 0x06000C38 RID: 3128 RVA: 0x0003E07B File Offset: 0x0003C27B
	public override int GetVertexCount()
	{
		return 1;
	}

	// Token: 0x06000C39 RID: 3129 RVA: 0x0003E07E File Offset: 0x0003C27E
	public override void Slice()
	{
		this.breakForceBuffer = 0f;
	}

	// Token: 0x06000C3A RID: 3130 RVA: 0x0003E08B File Offset: 0x0003C28B
	protected override void Start()
	{
		base.Start();
		this.breakForceBuffer = this.currentBreakingForce;
		if (this.lineRenderer.startColor == this.LegacyColour)
		{
			base.SetColor(Color.white);
		}
	}

	// Token: 0x06000C3B RID: 3131 RVA: 0x0003E0C4 File Offset: 0x0003C2C4
	protected override void JointBroken()
	{
		GameObject gameObject = new GameObject("steel break effect");
		gameObject.transform.position = base.transform.position;
		gameObject.AddComponent<DeleteAfterTime>().Life = 4f;
		gameObject.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
		AudioSource audioSource = gameObject.AddComponent<AudioSource>();
		audioSource.loop = false;
		audioSource.spatialBlend = 1f;
		audioSource.dopplerLevel = 0f;
		audioSource.playOnAwake = false;
		audioSource.PlayOneShot(Resources.LoadAll<AudioClip>("Audio/steel break").PickRandom<AudioClip>(), UnityEngine.Random.value);
	}
	public void ResetText()
	{
		//a null error here somewhere, please fix
		Debug.Log("ResetText");
		Debug.Log("im actually doing something");
		Debug.Log(base.lineRenderer.ToString());
		Debug.Log(this.lineRenderer.sharedMaterial.ToString());
		Debug.Log(this.lineRenderer.material.ToString());
		Debug.Log(this.WireMaterial.ToString());
		try {
		this.lineRenderer.material = this.WireMaterial;
		}
		catch (Exception E)
		{
			
		}
		Debug.Log("method 2");
		base.lineRenderer.material = this.WireMaterial;
	}
	// Token: 0x06000C3C RID: 3132 RVA: 0x0003E150 File Offset: 0x0003C350
	protected override void Created()
	{
		this.stress = Resources.LoadAll<AudioClip>("Audio/metal stress/");
		this.audioSource = this.lineRenderer.gameObject.AddComponent<AudioSource>();
		this.lineRenderer.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
		this.audioSource.loop = false;
		this.audioSource.spatialBlend = 1f;
		this.audioSource.dopplerLevel = 0f;
		this.audioSource.playOnAwake = false;
		this.WireColor = Color.white;
		this.lineRenderer.startColor = Color.white;
		this.lineRenderer.endColor = Color.white;
		this.lineRenderer.numCapVertices = 0;
		this.lineRenderer.sortingLayerName = "Background";
		this.lineRenderer.textureMode = LineTextureMode.Tile;
	}

	// Token: 0x06000C3D RID: 3133 RVA: 0x0003E220 File Offset: 0x0003C420
	protected override void Tick()
	{
		if (UnityEngine.Random.value > 0.9995f && this.typedJoint.reactionForce.magnitude / this.typedJoint.breakForce > 0.2f)
		{
			this.audioSource.PlayOneShot(this.stress.PickRandom<AudioClip>(), 0.5f);
		}
		float num = 0f;
		if (this.physicalBehaviour)
		{
			num = this.physicalBehaviour.BurnProgress;
		}
		if (this.otherPhysicalBehaviour)
		{
			num = Mathf.Max(num, this.otherPhysicalBehaviour.BurnProgress);
		}
		this.typedJoint.breakForce = this.breakForceBuffer * (1f - num);
	}
	public LineRenderer GetRenderer()
	{
		return this.lineRenderer;
	}
	// Token: 0x04000AF9 RID: 2809
	[SkipSerialisation]
	protected AudioSource audioSource;
	// Token: 0x04000AFA RID: 2810
	[SkipSerialisation]
	protected AudioClip[] stress;

	// Token: 0x04000AFB RID: 2811
	protected float breakForceBuffer = 1f;
}
	public class savemute : MonoBehaviour
	{
		public void Start()
		{
			gameObject.GetComponent<AudioSource>().mute = muted;
		}
		public bool muted = true;
	}
	public class mutepowah : ToolBehaviour
{
    public override void OnToolChosen()
    {
    }
    public override void OnToolUnchosen()
    {
    }
    public override void OnSelect()
    {
		if(ActiveSingleSelected)
		{
        AudioSource audio = ActiveSingleSelected.gameObject.GetComponent<AudioSource>();
    if(audio != null)
    {
		ModAPI.Notify("Muted/Unmuted an object.");
        audio.mute = !audio.mute; 
		savemute savmut;
		savmut = ActiveSingleSelected.gameObject.GetComponent<savemute>();
    if(savmut == null)
    {
	savmut = ActiveSingleSelected.gameObject.AddComponent(typeof(savemute)) as savemute;
	}
	else
	{
		UnityEngine.Object.Destroy(savmut);
	}
	//ModAPI.Notify(savmut.muted.ToString());
		savmut.muted = audio.mute;
    }
		}
    }
    public override void OnHold()
    {
    }
    public override void OnFixedHold()
    {
    }
    public override void OnDeselect()
    {
    }
}
public class savetransparency : MonoBehaviour
	{
		public void Start()
		{
			InvisibilityPower.MakeInvisible(gameObject,invis);
		}
		public bool invis = false;
	}
	public class InvisibilityPower : ToolBehaviour
{
	//List<savetransparency> invisobjects = new List<savetransparency>();
	public static void MakeInvisible(GameObject obj,bool state = true,bool preview = false)
	{
		SpriteRenderer rend = obj.GetComponent<SpriteRenderer>();
		Color32 clr = rend.color;
		if(state)
		{
		clr.a = 0;
		}
		else
		{
			if(!preview){clr.a = 255;}else {clr.a = 255/2;}
		}
		rend.color = clr;
		GameObject glower = obj.transform.Find("glow").gameObject;
		if(glower)
		{
			glower.GetComponent<SpriteRenderer>().enabled = !state;
		}
	}
    public override void OnToolChosen()
    {
    }
    public override void OnToolUnchosen()
    {
    }
    public override void OnSelect()
    {
		if(ActiveSingleSelected)
		{
		ModAPI.Notify("Changed an object.");
		savetransparency savmut = ActiveSingleSelected.gameObject.GetOrAddComponent<savetransparency>();
		savmut.invis = !savmut.invis;
		savmut.Start();
    }
    }
    public override void OnHold()
    {
    }
    public override void OnFixedHold()
    {
    }
    public override void OnDeselect()
    {
    }
}
public class maintainnocolsave : MonoBehaviour
	{
		public void Start()
		{
			if(other)
			foreach(Collider2D colone in GetComponents<Collider2D>())
			{
				foreach(Collider2D coltwo in other.GetComponents<Collider2D>())
				{
					Physics2D.IgnoreCollision(coltwo, colone,dewit);
				}
			}
			//Physics2D.IgnoreCollision(other, GetComponent<Collider2D>(),dewit);
		}
		public GameObject other = null;
		public bool dewit = true;
	}
	public class rendertomouse : MonoBehaviour
	{
		void Update()
		{
			Vector3 pos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
			pos.z = 0f;
			ModAPI.Draw.Line(gameObject.transform.position,pos);
		}
	}
	public class NoColPower : DistanceWireTool
{
	// Token: 0x060008C7 RID: 2247 RVA: 0x0002DC35 File Offset: 0x0002BE35
	string ModPath = "";
	private void Awake()
	{
		this.AllowNothingConnection = false;
		Material what = Instantiate(Resources.Load<Material>("Materials/SteelBinding"));
	this.WireMaterial = what;
	ModPath = ContraptionUtilities.ModPath();
  //Debug.Log(ModPath.Replace(@"\mod.json",""));
  //Debug.Log(ModPath.Replace(@"\mod.json","")+@"\nocoll.png");
	Texture WireTexture = ContraptionUtilities.LoadTexture("nocoll.png");//ModAPI.LoadTexture("nocoll.png",true);
	WireTexture.wrapMode = TextureWrapMode.Repeat;
	this.WireMaterial.mainTexture = WireTexture;
    this.WireWidth = 0.025f;
    this.WireColor = Color.white;
	}

	// Token: 0x060008C8 RID: 2248 RVA: 0x0002DC5D File Offset: 0x0002BE5D
	public override void OnToolChosen()
	{
		base.OnToolChosen();
		this.lineRenderer.numCapVertices = 0;
	}

	// Token: 0x060008C9 RID: 2249 RVA: 0x0002DC74 File Offset: 0x0002BE74
	protected override void OnJointCreate(DistanceJoint2D joint)
	{
		//if(joint.connectedBody.gameObject.GetComponent<PhysicalBehaviour>() != null)
		//{
		maintainnocolsave retard = joint.gameObject.AddComponent<maintainnocolsave>();
		retard.other = joint.connectedBody.gameObject;
		retard.Start();
		UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(retard, "nocol joint"));
		//}
		Destroy(joint);
	}
}
public class FixTextureSerialisation : MonoBehaviour
{
	void OnAfterDeserialise()
	{
					//Debug.Log("correct wire");
					Debug.Log(binding.ToString());
					Debug.Log(texturename);
					Material what = Instantiate(Resources.Load<Material>("Materials/SteelBinding"));
					Debug.Log(what.ToString());
					binding.WireMaterial = what;
					Texture WireTexture = ContraptionUtilities.LoadTexture(texturename,FilterMode.Point);
					Debug.Log(WireTexture.ToString());
					WireTexture.wrapMode = TextureWrapMode.Repeat;
					binding.WireMaterial.mainTexture = WireTexture;
					Debug.Log("Now for the final touch.");
					binding.ResetText();
					//binding.OnMouseOverlapEvent(false); //smh zooi you dumbass you had to make the most important variables protected and i had to resort to using something thats not even supposed to work
					//binding.gameObject.transform.Find("Wire").gameObject.GetComponent<LineRenderer>().material = binding.WireMaterial;
		Debug.Log("deserialization");
	}
	
	public UnfuckedBinding binding;
	public string texturename = "";
}
public class DurableSteelBindingTool : FixedWireTool
{
  private void Awake()
  {
	Material what = Instantiate(Resources.Load<Material>("Materials/SteelBinding"));
	this.WireMaterial = what;
	Texture WireTexture = ContraptionUtilities.LoadTexture("durable.png",FilterMode.Point);
	WireTexture.wrapMode = TextureWrapMode.Repeat;
	this.WireMaterial.mainTexture = WireTexture;
    this.WireWidth = 0.125f;
    this.WireColor = new Color32(255,255,254,255);
  }

  protected override void OnJointCreate(FixedJoint2D joint, Vector2 worldSpaceEndpos)
  {
    UnfuckedBinding bindingBehaviour = joint.gameObject.AddComponent<UnfuckedBinding>();
	FixTextureSerialisation fix = joint.gameObject.AddComponent<FixTextureSerialisation>();
	fix.binding = bindingBehaviour;
	fix.texturename = "durable.png";
    UndoControllerBehaviour.RegisterAction((IUndoableAction) new ObjectCreationAction((UnityEngine.Object) bindingBehaviour, "durable steel binding"));
    bindingBehaviour.WireColor = this.WireColor;
    bindingBehaviour.WireMaterial = this.WireMaterial;
    bindingBehaviour.WireWidth = this.WireWidth;
    bindingBehaviour.typedJoint = joint;
    bindingBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable((AnchoredJoint2D) joint, 30000f);
    bindingBehaviour.typedJoint.breakTorque = Utils.CalculateBreakForceForCable((AnchoredJoint2D) joint, 30000f);
    if ((bool) (UnityEngine.Object) joint.connectedBody)
      bindingBehaviour.localRenderEndpoint = (Vector2) joint.connectedBody.transform.InverseTransformPoint((Vector3) worldSpaceEndpos);
    else
      bindingBehaviour.localRenderEndpoint = (Vector2) joint.transform.InverseTransformPoint((Vector3) worldSpaceEndpos);
  }
}
public class StrongSteelBindingTool : FixedWireTool
{
  private void Awake()
  {
    Material what = Instantiate(Resources.Load<Material>("Materials/SteelBinding"));
	this.WireMaterial = what;
	Texture WireTexture = ContraptionUtilities.LoadTexture("strong.png",FilterMode.Point);
	WireTexture.wrapMode = TextureWrapMode.Repeat;
	this.WireMaterial.mainTexture = WireTexture;
    this.WireWidth = 0.15f;
    this.WireColor = new Color32(255,255,253,255);
  }

  protected override void OnJointCreate(FixedJoint2D joint, Vector2 worldSpaceEndpos)
  {
    UnfuckedBinding bindingBehaviour = joint.gameObject.AddComponent<UnfuckedBinding>();
	FixTextureSerialisation fix = joint.gameObject.AddComponent<FixTextureSerialisation>();
	fix.binding = bindingBehaviour;
	fix.texturename = "strong.png";
    UndoControllerBehaviour.RegisterAction((IUndoableAction) new ObjectCreationAction((UnityEngine.Object) bindingBehaviour, "strong steel binding"));
    bindingBehaviour.WireColor = this.WireColor;
    bindingBehaviour.WireMaterial = this.WireMaterial;
    bindingBehaviour.WireWidth = this.WireWidth;
    bindingBehaviour.typedJoint = joint;
    bindingBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable((AnchoredJoint2D) joint, 60000f);
    bindingBehaviour.typedJoint.breakTorque = Utils.CalculateBreakForceForCable((AnchoredJoint2D) joint, 60000f);
    if ((bool) (UnityEngine.Object) joint.connectedBody)
      bindingBehaviour.localRenderEndpoint = (Vector2) joint.connectedBody.transform.InverseTransformPoint((Vector3) worldSpaceEndpos);
    else
      bindingBehaviour.localRenderEndpoint = (Vector2) joint.transform.InverseTransformPoint((Vector3) worldSpaceEndpos);
  }
}
public class TSCG : SpringCableBehaviour {
	
}
public class ToggleableSpringBehaviour : MonoBehaviour
{
	void Start(){fixstatus();}
	void fixstatus()
	{
		foreach(TSCG ggzooi in GetComponents<TSCG>())
		{
			ggzooi.typedJoint.enabled = active;
		}			
	}
	void Use()
	{
		active = !active;fixstatus();
	}
	public bool active = true;
	//public SpringJoint2D connection;
}
public class ToggleableSpringTool : SpringJointWireTool
{
	protected virtual void Awake()
	{
		this.WireMaterial = Resources.Load<Material>("Materials/SpringCable");
		this.WireWidth = 0.2f;
		this.WireColor = new Color32(0,255,0,255);
	}
	protected override void OnJointCreate(SpringJoint2D joint)
	{
		SpringCableBehaviour springCableBehaviour = joint.gameObject.AddComponent<TSCG>();
		springCableBehaviour.WireColor = this.WireColor;
		springCableBehaviour.WireMaterial = this.WireMaterial;
		springCableBehaviour.WireWidth = this.WireWidth;
		springCableBehaviour.typedJoint = joint;
		ToggleableSpringBehaviour TPB = joint.gameObject.GetOrAddComponent<ToggleableSpringBehaviour>();
		//TPB.connection = joint;
	}
}
}