using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using Newtonsoft.Json;
using UnityEngine;
using UnityEngine.Events;
namespace stickpart {
  public class QuickSelectSave {
    public string assetname = "";
  }
  public class QuickSelector: MonoBehaviour {
    private SettingsMenu SettingsInstance = null;
    private CatalogBehaviour Catalog;
	private SpawnableAsset current;
    void Start() {
      Catalog = FindObjectsOfType < CatalogBehaviour > ()[0];
	  string path = ContraptionUtilities.FixedModPath(ContraptionUtilities.ModPath())+"quickselectsave.json";
	  if (File.Exists(path))
	  current = Catalog.GetSpawnable(JsonConvert.DeserializeObject<string>(File.ReadAllText(path)));
    }
    void Update() {
		if(InputSystem.Up("qs_save-jimmyl"))
		{
			string path = ContraptionUtilities.FixedModPath(ContraptionUtilities.ModPath());
			current = Catalog.SelectedItem;
			File.WriteAllText(path+"quickselectsave.json",JsonConvert.SerializeObject(current.name));
			ModAPI.Notify("<size=24>Setting quickselect to: "+current.name);
		} else if (InputSystem.Up("qs_load-jimmyl") && current != null)
		{
			ModAPI.Notify("<size=24>Quickselecting to: "+current.name);
			Debug.Log(current.name);
			Catalog.SetItem(current);
		}
	}
  }
}