using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
namespace stickpart
{
	public class DialogCloserESC : MonoBehaviour 
	{
		void Update()
		{
			if (Input.GetKeyUp(KeyCode.Escape) && Mod.DialogsToClose.Count > 0 )
			{
				foreach(DialogBox dialog in Mod.DialogsToClose)
				{
					Mod.DialogsToClose.Remove(dialog);
				dialog.Close();
				}
			}
		}
	}
	public class SettingsMenu
	{
private DialogBox settingsdialog = null;
	   private int page = 0;
	   public void Open(DialogButton[] buttons,int itemsperpage = 3)
	   {
		   
		   if(settingsdialog != null)
		   {
			   Mod.DialogsToClose.Remove(settingsdialog);
		   settingsdialog.Close();
		   }
		   List<DialogButton> options = new List<DialogButton>();
		   //if(reset)
		   //buttons = prevbuttons;
		   bool doinsert = true;
		   Debug.Log(page);
		   for(int i = 0;i < itemsperpage;i++)
		   {
			   int ind = (itemsperpage * page)+i;
			   if(ind < buttons.Length)
			   {
			   options.Add(buttons[ind]);
			   //buttons[ind].ClosesDialogBox = false;
			   }
			   else {
			   doinsert = false;}
		   }
		   if(page>0)
		   {
			   options.Insert(0,new DialogButton("<color=yellow><<</color>", true, new UnityAction[1] {
                  (UnityAction)(() => {
					  page--;
					  this.Open(buttons,itemsperpage);
                  })
                }));
		   }
		   //Debug.Log(doinsert);
		   if(doinsert)
		   {
			   //Debug.Log("inserting >>");
		   options.Insert(options.Count,new DialogButton("<color=yellow>>></color>", true, new UnityAction[1] {
                  (UnityAction)(() => {
					  page++;
					  this.Open(buttons,itemsperpage);
                  })
                }));
		   }
		  ModAPI.Notify("<size=32>Press ESC to close dialog</size>");
		   settingsdialog = DialogBoxManager.Dialog("Settings\n<size=26>Press the below buttons to change options.</size>", options.ToArray());
		   Mod.DialogsToClose.Add(settingsdialog);
		 //if(!reset)
		 //FloatEnemyAI.prevbuttons = buttons;
	   }
	}
}